﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Opgave6_ConsoleApplication
{
    // her i samme fil for lettere at kunne vise frem

//    a)	Tilret så metoden Opret3Cirkler tilføjer 3 cirkel objekter til cirkelListe med radius 5,  13 og 7.
//b)	Tilret så metoden Opret3Cirkler sikre, at listen kun indeholder de  3 cirkler selv om den kaldes to gange efter hinanden. (listen tømmes)

    class Cirkel
    {
        public int Radius { get; private set; }
        public Cirkel(int radius)
        {
            this.Radius = radius;
        }
        public double BeregnOmkreds()
        {
            return ((2 * Math.PI) * this.Radius);
        }
    }
    class CirkelSamling
    {
        private List<Cirkel> cirkelListe = new List<Cirkel>();
        public void Opret3Cirkler()
        {
            Cirkel c1 = new Cirkel(5);
            Cirkel c2 = new Cirkel(13);
            Cirkel c3 = new Cirkel(7);
            cirkelListe.Add(c1);
            cirkelListe.Add(c2);
            cirkelListe.Add(c3);
        }
        public void TilføjNyCirkel(int radius)
        {
            cirkelListe.Add(new Cirkel(radius));
        }
        public int BeregnRadiusSum()
        {
            int radiusSum = 0;
            foreach (Cirkel enCirkel in cirkelListe)
            {
                radiusSum += enCirkel.Radius;
            }
            return radiusSum;
        }
        public Cirkel FindMindsteCirkel()
        {
            Cirkel mindsteCirkel = null;
            foreach (Cirkel enCirkel in cirkelListe)
            {
                if (mindsteCirkel == null || enCirkel.Radius < mindsteCirkel.Radius)
                    mindsteCirkel = enCirkel;
            }
            return mindsteCirkel;
        }
        public Cirkel FindMindsteCirkel_Alternativ_1()
        {
            Cirkel mindsteCirkel = null;
            int mindsteRadius = int.MaxValue;   // "provoker" udskiftning
            foreach (Cirkel enCirkel in cirkelListe)
            {
                if (enCirkel.Radius < mindsteRadius)
                {
                    mindsteRadius = enCirkel.Radius;
                    mindsteCirkel = enCirkel;
                }
            }
            return mindsteCirkel;
        }
        public Cirkel FindMindsteCirkel_Alternativ_2()
        {
            if (cirkelListe.Count == 0)
                return null;  // kan ikke findes
            Cirkel mindsteCirkel = cirkelListe[0];  // til nu er den mindst
            foreach (Cirkel enCirkel in cirkelListe)
            {
                if (enCirkel.Radius < mindsteCirkel.Radius)
                    mindsteCirkel = enCirkel;
            }
            return mindsteCirkel;
        }
        public Cirkel FindMindsteCirkel_Alternativ_3()
        {
            if (cirkelListe.Count == 0)
                return null;  // kan ikke findes
            Cirkel mindsteCirkel = cirkelListe[0];  // til nu er den mindst
            for (int index = 1; index < cirkelListe.Count; ++index )
            {
                if (cirkelListe[index].Radius < mindsteCirkel.Radius)
                    mindsteCirkel = cirkelListe[index];
            }
            return mindsteCirkel;
        }
        public Cirkel FindMindsteCirkel_Alternativ_4()
        {
            if (cirkelListe.Count == 0)
                return null;  // kan ikke findes
            int indexFormindsteCirkel = 0;  // til nu er den mindst
            for (int index = 1; index < cirkelListe.Count; ++index)
            {
                if (cirkelListe[index].Radius < cirkelListe[indexFormindsteCirkel].Radius)
                    indexFormindsteCirkel = index;
            }
            return cirkelListe[indexFormindsteCirkel];
        }
        public List<Cirkel> FindCirklerMedMindreRadius(int forStorRadius)
        {
            List<Cirkel> fundneCirkler = new List<Cirkel>();
            foreach (Cirkel enCirkel in cirkelListe)
            {
                if (enCirkel.Radius < forStorRadius)
                    fundneCirkler.Add(enCirkel);
            }
            return fundneCirkler;
        }
        public double BeregnRadiusGennemsnit()      // udnyt tidligere metode
        {
            int radiusSum = BeregnRadiusSum();
            double gennemsnit = ((double)radiusSum) / ((double)cirkelListe.Count);    // udregn med mange decimaler
            return gennemsnit;
        }
        public double BeregnRadiusGennemsnit_Alternativ_1() // samme skabelon som for sum
        {
            int radiusSum = 0;
            int antalCirkler = 0;
            foreach (Cirkel enCirkel in cirkelListe)
            {
                radiusSum += enCirkel.Radius;
                ++antalCirkler;
            }
            double gennemsnit = ((double)radiusSum) / ((double)antalCirkler);    // udregn med mange decimaler
            return radiusSum;
        }
    }

    class Opgave06
    {
        static void Main(string[] args)
        {
        }
    }

}
